Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class DecimalValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.NumericValue
                  net.sf.saxon.value.DecimalValue

All Implemented Interfaces:
  Serializable, Comparable, SequenceIterable, Item, ValueRepresentation

    public final class DecimalValue

extends NumericValue

A decimal value

See Also:
  Serialized Form

Field Summary
`static BigDecimal` | `BIG_DECIMAL_ONE`
`static BigDecimal` | `BIG_DECIMAL_ONE_MILLION`
`static BigInteger` | `BIG_INTEGER_TEN`
`static int` | `DIVIDE_PRECISION`
`static DecimalValue` | `ONE`
`static DecimalValue` | `ZERO`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`DecimalValue(BigDecimal value)` Constructor supplying a BigDecimal
`DecimalValue(double in)` Constructor supplying a double
`DecimalValue(long in)` Constructor supplying a long integer

Method Summary
`NumericValue` | `arithmetic(int operator, NumericValue other, XPathContext context)` Evaluate a binary arithmetic operator.
`static boolean` | `castableAsDecimal(CharSequence in)` Test whether a string is castable to a decimal value
`NumericValue` | `ceiling()` Implement the XPath ceiling() function
`int` | `compareTo(long other)` Compare the value to a long
`int` | `compareTo(Object other)` Compare the value to another numeric value
`AtomicValue` | `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`Object` | `convertToJava(Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`AtomicValue` | `copy(AtomicType typeLabel)` Create a copy of this atomic value, with a different type label
`static CharSequence` | `decimalToString(BigDecimal value)`
`boolean` | `effectiveBooleanValue()` Get the effective boolean value of the value
`NumericValue` | `floor()` Implement the XPath floor() function
`CharSequence` | `getCanonicalLexicalRepresentation()` Get the canonical lexical representation as defined in XML Schema.
`BigDecimal` | `getDecimalValue()` Get the value
`BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
`Comparable` | `getSchemaComparable()` Get a Comparable value that implements the XML Schema ordering comparison semantics for this value.
`String` | `getStringValue()` Get the value as a String
`CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
`int` | `hashCode()` Get the hashCode.
`boolean` | `isWholeNumber()` Determine whether the value is a whole number, that is, whether it compares equal to some integer
`static AtomicValue` | `makeDecimalValue(CharSequence in, boolean validate)` Factory method to construct a DecimalValue from a string
`NumericValue` | `negate()` Negate the value
`NumericValue` | `round()` Implement the XPath round() function
`NumericValue` | `roundHalfToEven(int scale)` Implement the XPath round-half-to-even() function
`double` | `signum()` Determine whether the value is negative, zero, or positive

Methods inherited from class net.sf.saxon.value.NumericValue
`equals, getDoubleValue, getFloatValue, getXPathComparable, isInteger, isNaN, longValue, parseNumber, promote, toString`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, getCardinality, getComponent, getItemType, getLength, getTypedValue, getTypeLabel, hasBuiltInType, isMultiValued, itemAt, iterate, process, setTypeLabel`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convert, convertJavaObjectToXPath, fromItem, getIterator, iterate, makeQNameValue, reduce, stringToNumber`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### DIVIDE_PRECISION

    public static final int DIVIDE_PRECISION

See Also:
  Constant Field Values

### BIG_DECIMAL_ONE

    public static final BigDecimal BIG_DECIMAL_ONE

### BIG_INTEGER_TEN

    public static final BigInteger BIG_INTEGER_TEN

### BIG_DECIMAL_ONE_MILLION

    public static final BigDecimal BIG_DECIMAL_ONE_MILLION

### ZERO

    public static final DecimalValue ZERO

### ONE

    public static final DecimalValue ONE

Constructor Detail

### DecimalValue

    public DecimalValue(BigDecimal value)

  Constructor supplying a BigDecimal

  Parameters:
    `value` - the value of the DecimalValue

### DecimalValue

    public DecimalValue(double in)
                 throws ValidationException

  Constructor supplying a double

  Parameters:
    `in` - the value of the DecimalValue
  Throws:
    `ValidationException`

### DecimalValue

    public DecimalValue(long in)

  Constructor supplying a long integer

  Parameters:
    `in` - the value of the DecimalValue

Method Detail

### makeDecimalValue

    public static AtomicValue makeDecimalValue(CharSequence in,
                                               boolean validate)

  Factory method to construct a DecimalValue from a string

  Parameters:
    `in` - the value of the DecimalValue
    `validate` - true if validation is required; false if the caller knows that the value is valid
  Returns:
    the required DecimalValue if the input is valid, or an ErrorValue encapsulating the error message if not.

### castableAsDecimal

    public static boolean castableAsDecimal(CharSequence in)

  Test whether a string is castable to a decimal value

### copy

    public AtomicValue copy(AtomicType typeLabel)

  Create a copy of this atomic value, with a different type label

  Specified by:
    `copy` in class `AtomicValue`
  Parameters:
    `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Specified by:
    `getPrimitiveType` in class `AtomicValue`

### getDecimalValue

    public BigDecimal getDecimalValue()

  Get the value

  Overrides:
    `getDecimalValue` in class `NumericValue`
  Returns:
    a decimal representing this numeric value;

### hashCode

    public int hashCode()

  Get the hashCode. This must conform to the rules for other NumericValue hashcodes

  Specified by:
    `hashCode` in class `NumericValue`
  Returns:
    the hash code of the numeric value
  See Also:
    `NumericValue.hashCode()`

### effectiveBooleanValue

    public boolean effectiveBooleanValue()

  Description copied from class: `AtomicValue`
  Get the effective boolean value of the value

  Overrides:
    `effectiveBooleanValue` in class `AtomicValue`
  Returns:
    true, unless the value is boolean false, numeric zero, or zero-length string

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Specified by:
    `convertPrimitive` in class `AtomicValue`
  Parameters:
    `requiredType` - type code of the required atomic type
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
    `context` - The conversion context to be used. This is required at present only when converting to xs:Name or similar types: it determines the NameChecker to be used.
  Returns:
    the result of the conversion, if successful. If unsuccessful, the value returned will be a ValidationErrorValue. The caller must check for this condition. No exception is thrown, instead the exception will be encapsulated within the ValidationErrorValue.

### getStringValueCS

    public CharSequence getStringValueCS()

  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Overrides:
    `getStringValueCS` in class `AtomicValue`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### getCanonicalLexicalRepresentation

    public CharSequence getCanonicalLexicalRepresentation()

  Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules. For xs:decimal, the canonical representation always contains a decimal point.

  Overrides:
    `getCanonicalLexicalRepresentation` in class `Value`

### getStringValue

    public String getStringValue()

  Get the value as a String

  Specified by:
    `getStringValue` in interface `Item`
  Specified by:
    `getStringValue` in interface `ValueRepresentation`
  Specified by:
    `getStringValue` in class `AtomicValue`
  Returns:
    a String representation of the value
  See Also:
    `Item.getStringValueCS()`

### decimalToString

    public static CharSequence decimalToString(BigDecimal value)

### negate

    public NumericValue negate()

  Negate the value

  Specified by:
    `negate` in class `NumericValue`
  Returns:
    a value, of the same type as the original, with its sign inverted

### floor

    public NumericValue floor()

  Implement the XPath floor() function

  Specified by:
    `floor` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards minus infinity

### ceiling

    public NumericValue ceiling()

  Implement the XPath ceiling() function

  Specified by:
    `ceiling` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards plus infinity

### round

    public NumericValue round()

  Implement the XPath round() function

  Specified by:
    `round` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards the nearest whole number (0.5 rounded up)

### roundHalfToEven

    public NumericValue roundHalfToEven(int scale)

  Implement the XPath round-half-to-even() function

  Specified by:
    `roundHalfToEven` in class `NumericValue`
  Parameters:
    `scale` - the decimal position for rounding: e.g. 2 rounds to a multiple of 0.01, while -2 rounds to a multiple of 100
  Returns:
    a value, of the same type as the original, rounded towards the nearest multiple of 10**(-scale), with rounding towards the nearest even number if two values are equally near

### signum

    public double signum()

  Determine whether the value is negative, zero, or positive

  Specified by:
    `signum` in class `NumericValue`
  Returns:
    -1 if negative, 0 if zero, +1 if positive, NaN if NaN

### isWholeNumber

    public boolean isWholeNumber()

  Determine whether the value is a whole number, that is, whether it compares equal to some integer

  Specified by:
    `isWholeNumber` in class `NumericValue`
  Returns:
    true if the value is a whole number

### arithmetic

    public NumericValue arithmetic(int operator,
                                   NumericValue other,
                                   XPathContext context)
                            throws XPathException

  Evaluate a binary arithmetic operator.

  Specified by:
    `arithmetic` in class `NumericValue`
  Parameters:
    `operator` - the binary arithmetic operation to be performed. Uses the constants defined in the Token class, for example `Token.PLUS`, `Token.MINUS`
    `other` - the second operand
  Returns:
    the result of the arithmetic operation
  Throws:
    `XPathException` - if an arithmetic error occurs
  See Also:
    `Tokenizer`

### compareTo

    public int compareTo(Object other)

  Compare the value to another numeric value

  Specified by:
    `compareTo` in interface `Comparable`
  Overrides:
    `compareTo` in class `NumericValue`
  Parameters:
    `other` - The other numeric value
  Returns:
    -1 if this one is the lower, 0 if they are numerically equal, +1 if this one is the higher.

### compareTo

    public int compareTo(long other)

  Compare the value to a long

  Specified by:
    `compareTo` in class `NumericValue`
  Parameters:
    `other` - the value to be compared with
  Returns:
    -1 if this is less, 0 if this is equal, +1 if this is greater or if this is NaN

### getSchemaComparable

    public Comparable getSchemaComparable()

  Get a Comparable value that implements the XML Schema ordering comparison semantics for this value. Returns null if the value is not comparable according to XML Schema rules. The default implementation returns the value itself if it is comparable, or null otherwise. This is modified for types such as xs:duration which allow ordering comparisons in XML Schema, but not in XPath.

  In the case of data types that are partially ordered, the returned Comparable extends the standard semantics of the compareTo() method by returning the value `Value.INDETERMINATE_ORDERING` when there is no defined order relationship between two given values.

  Overrides:
    `getSchemaComparable` in class `Value`

### convertToJava

    public Object convertToJava(Class target,
                                XPathContext context)
                         throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `Value`
  Throws:
    `XPathException`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.